/*
  copyright(c) 2006 Miki Akiyoshi
  
  This file is part of Miki Memo
  
  Miki CoreLibrary is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki CoreLibrary is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki CoreLibrary; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.memo ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.util.* ;
import jp.dip.ikim.core.* ;

public class mkAddArrowAction implements mkPickSomeAction
{
    protected mkStore _st ;
    protected mkData  _old ;

    public mkAddArrowAction()
    {

    }

    public mkAddArrowAction(mkStore arg)
    {
	_st = arg ;
    }

    public mkOneSearch getOneSearch(mkPoint sp) 
    {
	mkOneSearch os = new mkOneSearch(_st, sp) ;

	return os ;
	
    }

    public void pickup(mkSimpleApplet app, mkScreen sc, 
		       java.util.List target,
		       mkPoint ap, MouseEvent ev)
    {
	mkArrowData ad = new mkArrowData() ;

	mkSimpleData  d1 = (mkSimpleData )target.get(0) ;
	mkShape s1 = d1.getShape() ;
	d1.setShape(new mkArrowShape(s1, ad)) ;

	mkSimpleData  d2 = (mkSimpleData )target.get(1) ;
	mkShape s2 = d2.getShape() ;
	d2.setShape(new mkArrowShape(s2, ad)) ;

	ad.set_line_color(app.config().getLineColor()) ;
	ad.set_fill_color(null) ;
	ad.setTextShape(null) ;

	// app.getScreen().get_tree().insertData(ad) ;

	sc.set_offscreen_mode(false) ;

	ad.draw(app.getScreen()) ;

	sc.set_offscreen_mode(true) ;

	_old = null ;
	
    }	

    public void searching(mkSimpleApplet app, mkScreen sc, mkData target,
			  mkPoint ap)
    {
	if(_old != null){
	    sc.redraw(_old) ;
	} 
	draw_x(sc, target) ;

	_old = target ;
    }

    private void draw_x(mkScreen sc, mkData target)
    {
	sc.set_offscreen_mode(false) ;

	mkRegion rg = target.get_bbox() ;

	sc.set_line_color(Color.red) ;
	
	sc.line(rg.get_sx(), rg.get_sy(), rg.get_ex(), rg.get_ey()) ;

	sc.line(rg.get_sx(), rg.get_ey(), rg.get_ex(), rg.get_sy()) ;

	sc.set_offscreen_mode(true) ;

    }

    public void doublep(mkSimpleApplet app, mkScreen sc, mkPoint sp) 
    {

    }

    public void reset(mkSimpleApplet app, mkScreen sc, mkMouse m)
    {
	_old = null ;
	
	sc.set_offscreen_mode(true) ;
    }
    

    public void drag(mkSimpleApplet app, mkScreen sc, 
		     java.util.List target, mkPoint p) 
    {

    }

    public void finish(mkSimpleApplet app, mkScreen sc, 
		       java.util.List target, mkPoint p) 
    {

    }

}

