/*
  copyright(c) 2006 Miki Akiyoshi
  
  This file is part of Miki Memo.
  
  Miki Memo is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki Memo is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki Memo; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.memo ;


import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import java.beans.* ;
import java.io.* ;
import java.util.* ;
import java.awt.datatransfer.* ;
import java.util.prefs.Preferences ;
import jp.dip.ikim.core.* ;


import static jp.dip.ikim.core.mkConfig.DIR_NAME ;
import static jp.dip.ikim.core.mkConfig.DEF_DIR_NAME ;

public class mkApplet extends mkSimpleApplet
{
    public static final double[] SMALL_PAPER = {200.0, 225.0} ;
    public static final double[] LARGE_PAPER = {400.0, 480.0} ;

    public static final String LAST_FILE_NAME = "last_file_name" ;

    public static final double WIDTH=2000.0 ;

    public static final int LAYER_PAPER = 1 ;
    public static final int LAYER_SUBJECT = 2 ;

    public static final String REC_TIME = "R[hԊuibj" ;
    public static final String DEF_REC_TIME = "60" ;

    public static final String SVG_NAME = "SVGt@C" ;
    public static final String DEF_SVG_NAME = "memo.svg" ;

    public static final String TMAP_JAR = "ThinkingMap(JARt@C)" ;
    public static final String
	DEF_TMAP_JAR = "mikithinkingmap20.jar" ;

    public static final String CMATRIX_JAR = "Matrix(JARt@C)" ;
    public static final String DEF_CMATRIX_JAR = 
	"mikicreativematrix10.jar" ;

    public static final String PLAYBACK_JAR = "vCobN(JARt@C)" ;
    public static final String DEF_PLAYBACK_JAR = 
	"mikiimageflip10.jar" ;



    private mkTextDialog  _txd ;

    private Dimension _od ;

    private boolean _delmode ;

    public mkApplet()
    {
	super() ;
    }

    static final String tl =
	"Miki Memo Ver 1.0 copyright(c) 2006 Miki Akiyoshi" ;

    public static void main(String[] args) 
    {
	JFrame frame = new JFrame(tl);

        mkApplet applet = new mkApplet() ;
	

	applet.setInitMode(args) ;

	applet.setSize(60, 80) ;
	
	frame.setLocationByPlatform(true) ;
	frame.getContentPane().add("Center", applet) ;
	
	frame.pack();
	frame.setSize(60, 80) ;

	applet.start() ;
	applet.init() ;
	
	frame.setVisible(true) ;

    }


    private mkLeftWidget left ;

    public mkLeftWidget getLeftWidget()
    {
	return left ;
    }

    private JMenuBar _bar1 ;
    private mkLabel   _lb1 ;

    private JMenuBar _bar2 ;
    private JTextField   _tx2 ;
    private JCheckBox   _cb2 ;
    private JButton   _btn2 ;
    private JPanel _panel2 ;
    private JList _list2 ;
    private JScrollPane _spane2 ;

    public void init()
    {
	super.init() ;

	getContentPane().setLayout(null) ;

	_cfg.add_line(REC_TIME,DEF_REC_TIME, null, mkConfig.TYPE.PLAIN) ;
	_cfg.add_line(SVG_NAME, DEF_SVG_NAME, null, mkConfig.TYPE.PLAIN) ;

	_cfg.add_line(TMAP_JAR,DEF_TMAP_JAR, null, mkConfig.TYPE.PLAIN) ;
	_cfg.add_line(CMATRIX_JAR,DEF_CMATRIX_JAR, null, mkConfig.TYPE.PLAIN);
	_cfg.add_line(PLAYBACK_JAR,DEF_PLAYBACK_JAR, null,mkConfig.TYPE.PLAIN);

	JMenu menu  = null ;
	JMenuItem mi  = null ;
	Class	c = getClass() ;
	Toolkit tk  = Toolkit.getDefaultToolkit() ;
	Image img = null ;

	_bar1 = createBar1(menu, mi, c, tk, img) ;

	setJMenuBar(_bar1) ;

	_lb1 = new mkLabel("Memo!") ;
	_lb1.setBounds(0,0,55,50) ;
	_lb1.setForeground(Color.blue) ;
	_lb1.setVerticalAlignment(SwingConstants.TOP) ;


	_lb1.addKeyListener(new KeyListener(){
		public void	keyPressed(KeyEvent e) {key_press(e);}
		public void	keyReleased(KeyEvent e) {}
		public void	keyTyped(KeyEvent e){} 
	    }) ;

	getContentPane().add(_lb1) ;

	create_popup(_lb1) ;

	// -----------------------------

	_bar2 = createBar2(menu, mi, c, tk, img) ;

	JToolBar toolBar = new JToolBar();

	JButton btn ;
	btn = new JButton( new ImageIcon(c.getResource("images/ti11.gif")));
	btn.addActionListener(new mkPickUp(this, null, 
					   new mkAllOneAction())) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("p̑");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti04.gif")));
	btn.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    newPaper() ;
		}}) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("Vp");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti06.gif")));
	btn.addActionListener(new mkPickUp(this, null, 
					   new mkTextEditAction())) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("eLXgҏW");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti10.gif")));
	btn.addActionListener(new mkRectRubber(this, new mkAddGroupAction())) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("O[vɂ܂Ƃ߂");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti13.gif")));
	btn.addActionListener(new mkPickSome(this,null , 2,
					     new mkAddArrowAction()));
	btn.setBackground(Color.white) ;
	btn.setToolTipText("Ђ");
	toolBar.add(btn) ;


	btn = new JButton( new ImageIcon(c.getResource("images/ti08.gif")));
	img = tk.createImage(c.getResource("images/icon05.gif")) ;
	btn.addActionListener(new mkPickUp(this, img, new mkDelAction())) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("폜");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti07.gif")));
	btn.addActionListener(new mkPickUp(this, null, new mkMoveAction())) ;
	btn.setBackground(Color.white) ;
	btn.setToolTipText("ړ");
	toolBar.add(btn) ;

	toolBar.addSeparator() ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti01.gif")));
	btn.addActionListener(new mkRectRubber(this,new mkEnlargeAction()));
	btn.setBackground(Color.white) ;
	btn.setToolTipText("g");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti02.gif")));
	btn.addActionListener(new mkRectRubber(this, new mkShrinkAction()));
	btn.setBackground(Color.white) ;
	btn.setToolTipText("k");
	toolBar.add(btn) ;

	btn = new JButton( new ImageIcon(c.getResource("images/ti03.gif")));
	img = tk.createImage(c.getResource("images/icon03.gif")) ;
	btn.addActionListener(new mkScrollAction(this, img)) ;
	btn.setBackground(Color.white) ;			
	btn.setToolTipText("XN[");
	toolBar.add(btn) ;

	_panel2 = new JPanel(new BorderLayout());
	_panel2.setBounds(0, 0, 905, 50) ;
	_panel2.add(BorderLayout.NORTH,toolBar);

	left = new mkLeftWidget() ;

	left.create(this) ;
	
	getScreen().set_font(get_fno()) ;

	_tx2 = new JTextField() ;
	_tx2.setBounds(5, 60, 165, 20) ;
	_tx2.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    search(e) ;
		}}) ;

	_cb2 = new JCheckBox("ǉ") ;
	_cb2.setBounds(5, 85, 60, 20) ;

	_lmodel = new DefaultListModel() ;
	_list2 = new JList(_lmodel) ;
	_list2.setValueIsAdjusting(true) ;

	_list2.addListSelectionListener(new ListSelectionListener(){
		public void valueChanged(ListSelectionEvent e)
		{
		    disp(e) ;
		}
	    }) ;
	

	_spane2 = new JScrollPane(_list2) ;
	_spane2.setBounds(5,140, 165, 510) ;	
	_spane2.setVerticalScrollBarPolicy(
					   JScrollPane.VERTICAL_SCROLLBAR_ALWAYS) ;
        _spane2.setPreferredSize(new Dimension(160, 270));

	_btn2 = new JButton("j") ;
	_btn2.setBounds(5, 115, 60, 20) ;
	_btn2.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    del_paper() ;
		}}) ;

	// ---------------------------------------------

	_txd = new mkTextDialog(this, getFrame(), "") ;

	_lb1.requestFocusInWindow() ;

	//Oۑt@Cǂݍ
	try {
	    load() ;
	} catch(Exception ex){
	    mkSimpleApplet.showErrDialog(ex) ;
	}
    }

    public void resize_event() 
    {
	Dimension d = getSize() ;
	
	// 炭LargeSize[h
	if(d.width > 180){
	    this.setSize(d.width, d.height) ;
	    getScreen().setSize(d.width - 175 - 5, d.height-60-5) ;
	    _panel2.setSize(d.width, 50) ;
	}
    }
	
    public void start_search()
    {
	_tx2.setText("") ;
	_tx2.requestFocus() ;
    }

    public void finish_event()
    {
	_sal.flush() ;

	if(_tool_mode){
	    getFrame().dispose() ;
	} else {
	    System.exit(0) ;
	}
    }

    public void sizeLarge()
    {
	getContentPane().removeAll() ;

	setJMenuBar(_bar2) ;
	JFrame frame = getFrame() ;

	if(_od == null){
	    _od = new Dimension(920, 700) ;
	}

	this.setSize(_od) ;

	getContentPane().add(_panel2) ;

	getContentPane().add(getScreen()) ;

	getContentPane().add(_tx2) ;
	getContentPane().add(_cb2) ;
	getContentPane().add(_btn2) ;
	getContentPane().add(_spane2) ;

	frame.pack() ;
	frame.setSize(_od) ;

	frame.paintAll(getGraphics()) ;

	getScreen().set_tree(new mkTree(0)) ;
	getScreen().set_view(0, 0, WIDTH, WIDTH) ;

	_tx2.requestFocusInWindow() ;
    }

    public void sizeSmall()
    {
	
	getContentPane().removeAll() ;

	setJMenuBar(_bar1) ;
	JFrame frame = getFrame() ;

	_od = frame.getSize() ;

	this.setSize(60, 80) ;
	getContentPane().add(_lb1) ;

	frame.pack() ;
	frame.setSize(60, 80) ;

	frame.paintAll(getGraphics()) ;

	mkTree tr = getScreen().get_tree() ;
	mkLayer lay = new mkLayer() ;
	lay.setMode(mkStore.MODE.ENABLE) ;
	lay.set_layer(LAYER_PAPER, mkStore.TYPE.ADD) ;

	mkAllSearch as = new mkAllSearch(lay) ;
	
	tr.search(as) ;

	java.util.List ls = as.get().get(0) ;

	for(int i = 0; i < ls.size(); i++){
	    mkPaperData dat = (mkPaperData )ls.get(i) ;
	    dat.del() ;
	}

	_lb1.requestFocusInWindow() ;

    }

    public void renew()
    {
	_lmodel.removeAllElements() ;
    }

    
    public mkTree create_tree()
    {
	mkTree tr = getScreen().get_tree() ;

	mkLayer lay = new mkLayer() ;
	lay.setMode(mkStore.MODE.ENABLE) ;
	lay.set_layer(LAYER_PAPER, mkStore.TYPE.ADD) ;

	mkAllSearch as = new mkAllSearch(lay) ;
	
	tr.search(as) ;

	java.util.List ls = as.get().get(0) ;

	for(int i = 0; i < ls.size(); i++){
	    mkPaperData dat = (mkPaperData )ls.get(i) ;
	    dat.del() ;
	}

	return new mkTree(0) ;
    }

    private DefaultListModel _lmodel ;

    public mkSimpleApplet load_data(ObjectInputStream arg) 
    {
	try {
	    if(arg != null){
		mkMemo memo = (mkMemo )arg.readObject() ;
		getScreen().set_tree(new mkTree(0)) ;
		
		_lmodel = memo.createModel() ;
		
		_list2.setModel(_lmodel) ;
	    }
	} catch(Exception ex){
	    mkSimpleApplet.showErrDialog(ex) ;
	}
	return this ;
    }

    public Object save_data() 
    {
	return new mkMemo(_lmodel) ;
    }

    public mkPaper create_paper(Clipboard arg)
    {
	mkPaper paper = null ;
	try {
	    paper = 
		create_paper((String )arg.getData(DataFlavor.stringFlavor)) ;
	    _lb1.message("܂") ;
	} catch(Exception ex){
	    mkSimpleApplet.showErrDialog(ex) ;
	}
	return paper ;
    }

    public mkPaper create_paper(String arg)
    {
	if(arg == null) return null ;

	mkPaper paper = new mkPaper(arg) ;

	paper.getTextBox().addApplet(this) ;

	_lmodel.addElement(paper) ;

	// ۑ
	save() ;

	return paper ;
    }

    public void del_paper()
    {
	_delmode = true ;

	_lmodel.remove(_list2.getSelectedIndex()) ;

	_list2.repaint() ;

	save() ;

	return ;
    }


    public void disp(ListSelectionEvent e)
    {
	if(_delmode){
	    _delmode = false ;
	    return ;
	}
	if(e.getValueIsAdjusting()){
	    return ;
	}
	Object obj = _list2.getSelectedValue() ;

	dispPaper((mkPaper )obj, false) ;
	return ;
    }

    public mkPaper dispPaper(mkPaper arg, boolean force)
    {
	return arg.disp(this, LARGE_PAPER[0], LARGE_PAPER[1], force) ;
    }

    public mkPaper dispPaper(mkPaper arg, double x, double y,
			     boolean force)
    {
	return  arg.disp(this, x, y-LARGE_PAPER[1], 
			 LARGE_PAPER[0], LARGE_PAPER[1], force) ;
    }


    public mkPaper newPaper()
    {
	return newPaper("Vp") ;
    }

    public mkPaper newPaper(String args)
    {
	mkPoint po = getScreen().dc2wc(5, 5) ;
	
	return newPaper(args, po) ;
    }

    public mkPaper newPaper(String args, mkPoint po)
    {
	mkPaper par = create_paper(args) ;
	if(par == null) return null ;
	return dispPaper(par, po.get_x(), po.get_y(),false) ;
    }



    public void search(ActionEvent e)
    {
	// ǉ[hłȂΈUʂNA
	if(! _cb2.isSelected()){
	    getScreen().set_tree(create_tree()) ;
	    getScreen().repaint() ;
	}

	String arg = _tx2.getText() ;

	for(int i = 0; i < _lmodel.getSize(); i++){
	    mkPaper pr = (mkPaper )_lmodel.getElementAt(i) ;
	    int idx = pr.search(arg) ;
	    if(idx != -1){
		dispPaper(pr, false) ;
	    }
	}
    }

    public void key_press(KeyEvent e)
    {

	char ch = e.getKeyChar() ;

	if(ch == 'n' || ch == 'N'){
	    _txd.show() ;
	} else if(ch == 'm' || ch == 'M'){
	    Clipboard cl = Toolkit.getDefaultToolkit().getSystemClipboard() ;
	    try {
		_txd.show((String )cl.getData(DataFlavor.stringFlavor)) ;
	    } catch(Exception ex){
		mkSimpleApplet.showErrDialog(ex) ;
	    }
	} else if(ch == 'v' || ch == 'V'){
	    create_paper(Toolkit.getDefaultToolkit().getSystemClipboard()) ;
	}
    }

    public mkNote createNote()
    {
	mkScreen sc = left.getScreen() ;

	mkNote note = new mkNote(sc.get_tree(), "Vm[g") ;

	getScreen().repaint() ;

	_lmodel.addElement(note) ;

	// ۑ
	save() ;

	dispPaper(note, false) ;

	return note ;
    }

    public JMenuBar createBar1(JMenu menu, JMenuItem mi,
			       Class	c, Toolkit tk, Image img)
    {

	JMenuBar b1 = new JMenuBar() ;

	menu = new JMenu("j[(M)") ;
	menu.setMnemonic(KeyEvent.VK_M);

	mi = new JMenuItem("t@CJ(O)", KeyEvent.VK_O) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_O, ActionEvent.CTRL_MASK));
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    load_from() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("Oĕۑ(A)", KeyEvent.VK_A) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    save_as() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("(F)", KeyEvent.VK_F) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_F, ActionEvent.CTRL_MASK));
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    sizeLarge() ;
		}}) ;
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("I(X)", KeyEvent.VK_X) ;
	mi.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
		finish_event() ;
	    }}) ;
	
	menu.add(mi) ;
	b1.add(menu) ;

	return b1 ;
    }

    public JMenuBar createBar2(JMenu menu, JMenuItem mi,
			       Class	c, Toolkit tk, Image img)
    {
	JMenuBar b2 = new JMenuBar() ;
	menu = new JMenu("t@C(F)") ;
	menu.setMnemonic(KeyEvent.VK_F);

	mi = new JMenuItem("t@CJ(O)", KeyEvent.VK_O) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_O, ActionEvent.CTRL_MASK));
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    load_from() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("Oĕۑ(A)", KeyEvent.VK_A) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    save_as() ;
		}}) ;
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("I(X)", KeyEvent.VK_X) ;
	mi.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
		finish_event() ;
	    }}) ;
	
	menu.add(mi) ;
	b2.add(menu) ;

	menu = new JMenu("ҏW(E)") ;
	menu.setMnemonic(KeyEvent.VK_E);

	mi = new JMenuItem("(F)", KeyEvent.VK_F) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_F, ActionEvent.CTRL_MASK));
	mi.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
		start_search() ;
	    }}) ;
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("Vp(K)", KeyEvent.VK_K) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    newPaper() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("eLXgҏW(T)", KeyEvent.VK_T) ;
	mi.addActionListener(new mkPickUp(this, null, 
					  new mkTextEditAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("폜(D)", KeyEvent.VK_D) ;
	img = tk.createImage(c.getResource("images/icon05.gif")) ;
	mi.addActionListener(new mkPickUp(this, img, new mkDelAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("ړ(M)", KeyEvent.VK_M) ;
	mi.addActionListener(new mkPickUp(this, null, new mkMoveAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("ύX(A)", KeyEvent.VK_A) ;
	//	mi.addActionListener(new mkAttribAction(this)) ;
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("O[vɂ܂Ƃ߂(P)", KeyEvent.VK_P) ;
	mi.addActionListener(new mkRectRubber(this,new mkAddGroupAction()));
	menu.add(mi) ;

	mi = new JMenuItem("Ђ(L)", KeyEvent.VK_L) ;
	mi.addActionListener(new mkPickSome(this,null , 2,
					    new mkAddArrowAction()));
	menu.add(mi) ;

	mi = new JMenuItem("m[gƂĕۑ(R)", KeyEvent.VK_R) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    createNote() ;
		}}) ;
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("ݒ") ;
	mi.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
		show_config() ;
	    }}) ;
	menu.add(mi) ;
	b2.add(menu) ;

	menu = new JMenu("\(V)") ;
	menu.setMnemonic(KeyEvent.VK_V);

	mi = new JMenuItem("(Q)", KeyEvent.VK_Q) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_Q, ActionEvent.CTRL_MASK));
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    sizeSmall() ;
		}}) ;
	menu.add(mi) ;

	menu.addSeparator();


	JMenu submenu = new JMenu("̑傫(C)") ;
	menu.setMnemonic(KeyEvent.VK_C);

	ButtonGroup group = new ButtonGroup();

	JRadioButtonMenuItem[] rb = new JRadioButtonMenuItem[5] ;
	rb[0] = new JRadioButtonMenuItem(FONT_NAME[0]) ;
	rb[0].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(0) ;
		}}) ;
	rb[0].setMnemonic(KeyEvent.VK_0);
	group.add(rb[0]) ;
	submenu.add(rb[0]) ;

	rb[1] = new JRadioButtonMenuItem(FONT_NAME[1]) ;
	rb[1].setMnemonic(KeyEvent.VK_1);
	rb[1].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(1) ;
		}}) ;
	group.add(rb[1]) ;
	submenu.add(rb[1]) ;

	rb[2] = new JRadioButtonMenuItem(FONT_NAME[2]) ;
	rb[2].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(2) ;
		}}) ;
	rb[2].setMnemonic(KeyEvent.VK_2);
	group.add(rb[2]) ;
	submenu.add(rb[2]) ;

	rb[3] = new JRadioButtonMenuItem(FONT_NAME[3]) ;
	rb[3].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(3) ;
		}}) ;
	rb[3].setMnemonic(KeyEvent.VK_3);
	group.add(rb[3]) ;
	submenu.add(rb[3]) ;

	rb[4] = new JRadioButtonMenuItem(FONT_NAME[4]) ;
	rb[4].addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    set_fno(4) ;
		}}) ;
	rb[4].setMnemonic(KeyEvent.VK_4);
	group.add(rb[4]) ;
	submenu.add(rb[4]) ;

	rb[get_fno()].setSelected(true) ;

	menu.add(submenu) ;

	mi = new JMenuItem("g(E)",KeyEvent.VK_E) ;
	mi.addActionListener(new mkRectRubber(this, new mkEnlargeAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("k(S)",KeyEvent.VK_S) ;
	mi.addActionListener(new mkRectRubber(this, new mkShrinkAction())) ;
	menu.add(mi) ;

	mi = new JMenuItem("XN[(T)", KeyEvent.VK_T) ;
	img = tk.createImage(c.getResource("images/icon03.gif")) ;
	mi.addActionListener(new mkScrollAction(this,img)) ;
	menu.add(mi) ;

	mi = new JMenuItem("ĕ\", KeyEvent.VK_T) ;
	//	mi.addActionListener(new mkRefleshAction(this)) ;
	menu.add(mi) ;


	submenu = new JMenu("LOOKFEEL") ;
	menu.setMnemonic(KeyEvent.VK_L);

	group = new ButtonGroup();
	rb = new JRadioButtonMenuItem[4] ;
	rb[0] = new JRadioButtonMenuItem("Windows") ;
	rb[0].addActionListener(new mkLookAndFeelAction(this, 0)) ;
	rb[0].setMnemonic(KeyEvent.VK_W);
	group.add(rb[0]) ;
	submenu.add(rb[0]) ;

	rb[1] = new JRadioButtonMenuItem("Linux") ;
	rb[1].setMnemonic(KeyEvent.VK_L);
	rb[1].addActionListener(new mkLookAndFeelAction(this, 1)) ;
	group.add(rb[1]) ;
	submenu.add(rb[1]) ;

	rb[2] = new JRadioButtonMenuItem("Java") ;
	rb[2].addActionListener(new mkLookAndFeelAction(this, 2)) ;
	rb[2].setMnemonic(KeyEvent.VK_J);
	group.add(rb[2]) ;
	submenu.add(rb[2]) ;

	rb[3] = new JRadioButtonMenuItem("Unix") ;
	rb[3].addActionListener(new mkLookAndFeelAction(this, 3)) ;
	rb[3].setMnemonic(KeyEvent.VK_U);
	group.add(rb[3]) ;
	submenu.add(rb[3]) ;

	rb[get_gno()].setSelected(true) ;

	menu.add(submenu) ;

	b2.add(menu) ;


	menu = new JMenu("c[(T)") ;
	menu.setMnemonic(KeyEvent.VK_T);


	mi = new JCheckBoxMenuItem("R[h") ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    record(e) ;
		}}) ;
	menu.add(mi) ;


	mi = new JMenuItem("vCobN") ;
	mi.addActionListener(new mkInvokToolAction("creativematrix",
						   config().get(PLAYBACK_JAR)));
	menu.add(mi) ;


	mi = new JMenuItem("SVGo(G)", KeyEvent.VK_G) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    createSVG() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("HTMLo(H)", KeyEvent.VK_H) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    //createHTML() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("TEXTo(T)", KeyEvent.VK_T) ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    createTEXT() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("ThinkingMap") ;
	mi.addActionListener(new mkInvokToolAction("thinkingmap",
						   config().get(TMAP_JAR)));
	menu.add(mi) ;

	mi = new JMenuItem("CreativeMatrix") ;
	mi.addActionListener(new mkInvokToolAction("creativematrix",
						   config().get(CMATRIX_JAR)));
	menu.add(mi) ;

	b2.add(menu) ;

	return b2 ;
    }
    
    public void createTEXT()
    {
	try {
	    for(int i = 0; i < _lmodel.size(); i++){
		mkPaper pap = (mkPaper )_lmodel.elementAt(i) ;
		Preferences pref = getPreferences() ;
		File fp = new File(pref.get(DIR_NAME, DEF_DIR_NAME),
				   pap.toString()+".txt") ;
		PrintWriter fw = 
		    new PrintWriter(new FileWriter(fp),true) ;
		fw.print(pap.get_text()) ;
		fw.close() ;
	    }
	} catch(Exception ex){
	    mkSimpleApplet.showErrDialog(ex) ;
	}
    }

    public mkSimpleApplet 
	drop(Transferable tr, Point pt) throws Exception
    {
	DataFlavor df = new DataFlavor(mkData.class, "Data");
	mkData dat = (mkData)(tr.getTransferData(df)) ;

	mkPoint po = getScreen().dc2wc(pt.x, pt.y) ;

	newPaper(dat.get_text(), po) ;

	return this ;
    }

    private void create_popup(mkLabel lb)
    {
	JPopupMenu menu = new JPopupMenu();

	JMenuItem mi  = null ;
	mi = new JMenuItem("Nbv{[h̓e") ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    create_paper(Toolkit.getDefaultToolkit().getSystemClipboard()) ;
		}}) ;

	menu.add(mi) ;

	mi = new JMenuItem("") ;
	mi.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    _txd.show() ;
		}}) ;
	menu.add(mi) ;

	mi = new JMenuItem("") ;
       menu.add(mi) ;

       lb.setComponentPopupMenu(menu) ;	
    }

    public void record(ActionEvent e)
    {
	JCheckBoxMenuItem mi=	(JCheckBoxMenuItem)e.getSource() ;
	
	if(mi.getState()){
	    Preferences pref = getPreferences() ;
	    
	    String path = pref.get(DIR_NAME, DEF_DIR_NAME) ;
	    
	    int sec = pref.getInt(REC_TIME, 
				  Integer.parseInt(DEF_REC_TIME)) ;

	    getScreen().record(path+"memo", sec) ;
	} else {
	    getScreen().record(null, 0) ;
	}
    }

    public void createSVG()
    {
	createSVG(config().get(SVG_NAME)) ;
    }


}

