/*
  copyright(c) 2006 Miki Akiyoshi
  
  This file is part of Miki Memo.
  
  Miki Memo is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki Memo is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki Memo; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.memo ;

import java.util.List ;
import java.util.ArrayList ;
import java.io.* ;
import jp.dip.ikim.core.* ;

public class mkNote  extends mkPaper
{
    static final long serialVersionUID = -6683695682157839674L;

    private mkData[]  _stock ;
    private mkSimpleData  _subject ;

    public mkNote(mkTree tree, String arg)
    {
	super(arg) ;

	mkLayer lay = new mkLayer() ;
	lay.set_layer(mkApplet.LAYER_SUBJECT, mkStore.TYPE.ADD) ;
	mkAllSearch as = new mkAllSearch(lay) ;
	
	tree.search(as) ;

	java.util.List ls = as.get().get(0) ;

	int siz = ls.size() ;
	_stock = new mkData[siz] ;

	for(int i = 0; i < siz; i++){
	    _stock[i] =(mkData )((mkData )ls.get(i)).clone() ;
	}

	_subject = new mkSimpleData() ;
	_subject.setTextShape(getTextBox()) ;
	_subject.set_fill_color(null) ;
	_subject.set_layer(mkApplet.LAYER_SUBJECT) ;

    }

    public mkPaper disp(mkApplet ap, double width, double height, 
			boolean force)
    {
	mkTree tr = ap.create_tree() ;

	for(int i = 0; i < _stock.length; i++){
	    tr.insertData(_stock[i].alive()) ;
	}

	mkScreen sc = ap.getScreen() ;
	sc.set_tree(tr) ;
	sc.enlarge(tr.get_bbox()) ;

	mkPoint sp = sc.dc2wc(5, 5) ;
	mkPoint[] po = 
	    mkPolygonShape.get_points(sp.get_x(), sp.get_y()-70, 800, 70);
	_subject.setShape(new mkPolygonShape(po)) ;

	tr.insertData(_subject.alive()) ;

	sc.redraw() ;
	
	getTextBox().addApplet(ap) ;
	return this ;
    }

    public int search(String arg)
    {
	return -1 ;
    }

}

