/*
  copyright(c) 2006 Miki Akiyoshi
  
  This file is part of Miki Memo.
  
  Miki Memo is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki Memo is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki Memo; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.memo ;


import java.util.* ;
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.beans.* ;
import java.io.* ;
import java.util.prefs.Preferences ;
import jp.dip.ikim.core.* ;

public class mkPaper  implements Serializable , Cloneable
{
    static final long serialVersionUID = -7128378564580425132L;

    mkPaperTextBox _tbox ;

    Date _date ;

    transient boolean _disp ;

    public Date getDate()
    {
	return _date ;
    }


    public boolean disp_p()
    {
	return _disp ;
    }

    public mkPaper disp(mkApplet ap, double width, double height,
			boolean force)
    {
	if(disp_p()) return null ;

	Random rad = new Random(new Date().getTime()) ;

	mkRegion vi = ap.getScreen().get_view() ;

	double x = rad.nextDouble()* (vi.width()-width) ;
	double y = rad.nextDouble()* (vi.height()-height) ;

	return disp(ap, vi.get_sx()+x, vi.get_sy()+y, 
		    width, height, force) ;
    }

    public mkPaper disp(mkApplet ap, double x, double y,
			double width, double height, boolean force)
    {
	if(disp_p()) return null ;

	mkPoint[] po = 
	    mkPolygonShape.get_points(x, y, width, height) ;

	mkPaperData pd  = new mkPaperData(new mkPolygonShape(po), this) ;
	pd.set_line_color(ap.config().getLineColor()) ;
	pd.set_fill_color(ap.config().getFillColor()) ;
	pd.set_text_color(ap.config().getTextColor()) ;
	pd.set_layer(ap.LAYER_PAPER) ;

	mkScreen sc = ap.getScreen() ;

	sc.get_tree().insertData(pd) ;

	sc.redraw() ;

	_disp = true ;

	getTextBox().addApplet(ap) ;

	return this ;
    }
    
    public mkPaper hide()
    {
	_disp = false ;

	return this ;
    }
	
    public mkPaper disp()
    {
	_disp = true ;

	return this ;
    }


    public mkPaper(String arg)
    {
	super() ;

	_date = new Date() ;

	_tbox = new mkPaperTextBox(arg) ;
    }

    public mkPaper()
    {
	super() ;

	_date = new Date() ;
    }

    public  Object clone() 
    {
	try {
	    mkPaper other = (mkPaper )super.clone();
	    return other;
	} catch (Exception e) {
	    // this shouldn't happen, since we are Cloneable
	    throw new InternalError();
	}
    }

    public mkPaperTextBox getTextBox()
    {
	return _tbox ;
    }

    public String get_text()
    {
	return _tbox.get_text() ;
    }

    public String toString()
    {
	return _tbox.get_multi_text()[0] ;
    }

    public int search(String arg)
    {
	return get_text().indexOf(arg) ;
    }
}

