/*
  copyright(c) 2006 Miki Akiyoshi
  
  This file is part of Miki Memo.
  
  Miki Memo is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki Memo is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki Memo; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.memo ;


import java.util.* ;
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.beans.* ;
import java.io.* ;
import java.util.prefs.Preferences ;
import jp.dip.ikim.core.* ;
import jp.dip.ikim.core.mkTextShape.ALIGN ;
import jp.dip.ikim.core.mkTextShape.VALIGN ;

public class mkPaperData  extends mkSimpleData
{
    static final long serialVersionUID = 8048023944814397475L;

    private mkPaper _paper ;

    public mkPaperData(mkPaper paper)
    {
	super() ;

	_paper = paper ;

	setTextShape(paper.getTextBox()) ;
    }

    public mkPaperData(mkPolygonShape poly, mkPaper paper)
    {
	super(poly) ;

	_paper = paper ;

	setTextShape(paper.getTextBox()) ;

	set_align(ALIGN.LEFT) ;
	set_valign(VALIGN.TOP) ;
    }

    public mkPaper getPaper()
    {
	return _paper ;
    }

    public  Object clone() 
    {
	try {
	    mkPaperData other = (mkPaperData )super.clone();
	    return other;
	} catch (Exception e) {
	    // this shouldn't happen, since we are Cloneable
	    throw new InternalError();
	}
    }

    public mkData del()
    {
	super.del() ;

	_paper.hide() ;

	return this ;
    }

    public mkData alive()
    {
	super.alive() ;

	_paper.disp() ;

	return this ;
    }

}

