/*
  copyright(c) 2006 Miki Akiyoshi
  
  This file is part of Miki CoreLibrary.
  
  Miki CoreLibrary is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki CoreLibrary is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki CoreLibrary; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.memo ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.io.* ;
import java.util.* ;
import java.awt.dnd.* ;
import javax.swing.text.*;
import java.util.prefs.Preferences ;
import jp.dip.ikim.core.* ;

public class mkTextDialog extends JDialog implements Serializable ,
						     ActionListener
{
    mkApplet _app ;

    JTextPane _txarea ;

    public mkTextDialog(mkApplet app, Frame frame, String title)
    {
	super(frame, title) ;

	setLocationByPlatform(true) ;

	_app = app ;

	getContentPane().setLayout(null) ;
        setSize(new Dimension(600, 510)) ;

	_txarea = new JTextPane() ;

	mkSimpleApplet.addTextBindings(_txarea) ;

	_txarea.addFocusListener(new FocusListener(){
		public void focusGained(FocusEvent e){} 
		public void focusLost(FocusEvent e){
		    action() ;
		}
	    }) ;

	JScrollPane spane = new JScrollPane(_txarea) ;

	spane.setBounds(5,5, 580,400) ;	
        spane.setVerticalScrollBarPolicy(
			  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS) ;
        spane.setPreferredSize(new Dimension(400, 270));
        spane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("e"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                spane.getBorder()));	

	JButton	btn = new JButton("Cancel") ;
	btn.setBounds(290, 415, 75, 35) ;
	btn.addActionListener(this) ;
	getContentPane().add(spane) ;
	getContentPane().add(btn) ;
    }

    public mkTextDialog set_text(String arg)
    {
	_txarea.setText(arg) ;

	return this ;
    }

    public void show(String arg)
    {
	set_text(arg) ;
	_txarea.requestFocusInWindow() ;
	super.show() ;
    }

    public void show()
    {
	show("") ;
    }
	
    public void action()
    {
	_app.create_paper(_txarea.getText()) ;

	hide() ;
    }

    public void actionPerformed(ActionEvent e)
    {
	hide() ;
    }

}


